module Main where

import System.IO

-- Jules Reactive

import Deus.Reactive
import Data.Time.Clock
--import Data.Time.Calendar
--import Data.Time.Format


----------------------------------------------

constFun :: Double -> UTCTime -> Double
constFun constval trash = constval

constB :: Double -> Behaviour Double
constB value = timeFunction (constFun value)

----------------------------------------------

furnaceUpdate :: Behaviour Double -> Event Int -> Behaviour Double
furnaceUpdate furnace ticker  = 
    (switcher (constB 25.0) (fmap constB
                             (accumE 25.0 (snapshotWith
                                           (\watts ticker -> (\temp -> temp+(watts/100.0)))
                                           furnace ticker))))

--------------------------------------------------------------------

controllerUpdate :: Behaviour Double -> Event Int -> Behaviour Double
controllerUpdate temp ticker  = (switcher (constB 0.0)
                                 (fmap constB 
                                  (snapshotWith
                                   (\temp tick -> (600.0 - temp) / 1000.0)
                                   temp ticker)))

----------------------------------------------------------------

furnaceMain :: Event Int -> Event (IO ())
furnaceMain ticker =
    let watts = (controllerUpdate temp ticker)
        temp = (furnaceUpdate watts ticker) in
        fmap (\result -> putStrLn $ "Temp -> " ++ show result)
             (snapshotWith (\t tick -> "\n" ++ show t)
              temp
              ticker)

----------------------------------------------------------------


----------
-- Main --
----------

main = do

    --hSetBuffering stdin NoBuffering
    --hSetBuffering stdout NoBuffering


    ticker <- timewiseIterate 10000 (+1) 0

    runReactor (furnaceMain ticker)

    putStrLn "Done .."
 
